\documentclass{article}
\usepackage[utf8]{inputenc}
\usepackage{graphicx}

\title{Sprint 2 - Final Report}
\author{Alain Mahieu, Hieu Le, Jeongkyeong Park, Liangkun He and Tomasz Karg}

\date{\today}

\begin{document}


\maketitle

\section{Sprint 2 planning}

    \begin{enumerate}
    	\item Tasks left from previous Sprint
    	\begin{itemize}
    		\item Footprint storage
    		\item Unit tests for Preprocessing
    		\item Documentation work
    	\end{itemize}
        \item Backend
        \begin{itemize}
        	\item Comparison between two footprints
        	\item Loading and saving process trees from files
        	\item Usage Documentation
            
        \end{itemize}
        \item Frontend
        \begin{itemize}
        	\item Basic Error Handling
        	\item Representation of Footprint tables
        	\item Representation of Process tree models     
        \end{itemize}
    \end{enumerate}

\section{Status}
	Our project is still split into a front-end server interface and a standalone back-end conformance checker. 
	
	The standalone conformance checker has now all functionalities it needs to make a footprint conformance checking. In the current state however the logical outcome of the process is still wrong. While the Footprint extraction of event logs and the comparison of two footprints are working as intended the extraction of a footprint from process trees is still broken. It produces a footprint with correct shape and activities but has wrong values in many cases. This will be something to be fixed in the next sprint. 
	
	The front-end server interface now has the ability to display footprint table and process model using pandas data frame. Since we do not integrate font and back end yet, we set the input path as /tests. To use our server, simply open a terminal window and navigate to footprints-conformance-checking/server and run the server by executing 
	
	\begin{center}
	 \begin{tabular}{|p{14.0cm}|}
	  \hline
	  python3 server.py\\
	  \hline
	 
	 \end{tabular}
	\end{center}
 
    
    \subsection{Achieved}
        In the following we described how much time we spent on each task. For details some tasks were added/removed/postponed/incomplete during the sprint.

    \begin{center}
        \begin{tabular}{|p{9.7cm}|p{1.65cm}|p{1.65cm}|}
        
            \hline
            Task & Spent time & Comment  \\
            \hline
        
        \end{tabular}    
    \end{center} 

    \textbf{Footprint Extraction Algorithm + Comparison (est: 15h, spent:17h)} \\
    	\begin{tabular}{|p{9.7cm}|p{1.65cm}|p{1.65cm}|}
    		
    		\hline
    		Implement functions to load and save Process Trees from files & 1h & Incomplete\\
    		\hline
    		Write Unittests for load/save functions & 0.5h & \\
    		\hline
    		Implement a direct approach to extract footprints from Process Trees & 8h & Incomplete + added \\
    		\hline
    		Adjust persisting unittests for process tree footprint extractor & 1h & \\
    		\hline
    		Implement a comparison between two footprints & 3h & \\
    		\hline 
    		Write unittests for the comparison between two footprints & 2h & \\
    		\hline
    		Outsourcing utility for footprint generation and reorganize project structure & 0.5h & \\
    		\hline
    		Research the PM4Py documentation & 1h & \\
    		\hline
    		Other & 1h & \\
    		\hline
    		
    	\end{tabular} \\ \\
    
    \textbf{Input preprocessing (est: 10h, spent:7h)} \\
    	\begin{tabular}{|p{9.7cm}|p{1.65cm}|p{1.65cm}|}
    	\hline
    	Implement unit test for preprocess function & 7h &\\
    	\hline

    	\end{tabular} \\ \\ 
    	
    \textbf{Footprint Storage (est: 5h, spent: 6h)} \\
        \begin{tabular}{|p{9.7cm}|p{1.65cm}|p{1.65cm}|}
        \hline
		Implement function to store footprint matrix as csv files & 6h &\\
		\hline
		
        \end{tabular} \\ \\

    \textbf{Server Interface (est: 8h, spent: 10h)} \\
        \begin{tabular}{|p{9.7cm}|p{1.65cm}|p{1.65cm}|}
       \hline
       Implement a function to represent footprint table & 2h & \\
       \hline
       unit test for server & 3h &\\
       \hline
       Implement a function to represent process model & 2h & \\
       \hline
       unit test for server & 3h &\\
      \hline
             
             
        \end{tabular} \\

    
\subsection{To-do}
For the back-end we will have to focus on getting the extraction of footprints from process trees correct. Though we cannot yet guarantee correct footprints we are now ready to merge front-end and back-end together in the next sprint and link functionalities respectively. The outcome of the next sprint should provide a usable server interface with the functionality of the main intended features for our project.
 
\section{Sprint review}
\subsection{Alain Mahieu}
"In this sprint I continued my work on the backend. After we got informed that our approach for the extraction of footprints from process trees is unsafe I started to implement a different approach we obtained from Alessandro. Right now the new approach produces footprints in the correct shape with correct extracted activities ready to be compared but the values are still wrong in many cases. I also worked on the comparison functionality to compare two footprints. To implement was straight forward and worked pretty good I think. Furthermore for cleanage purposes I decided to outsource some help functions for the footprint generation into a utility file and restructured the unittests accordingly. Took a bit time but I think it was worth it. I tried to implement some functions that can load and save process tree representations to files. I encountered a problem with tau-leafes to be changed in the process of storing it to a file. All together I think we made good effort in this spring but are left with alot more work still to be done."


\subsection{Hieu Le}
"In this sprint, I finished the undone works from the last sprint, which are the unit test for preprocessing part and the storage for footprint matrices. I had a little problem with the unit test because it was new to me but in general, I am interested in this praktikum and looking forward to finishing the remaining works."


\subsection{Jeongkyeong Park}
"In this sprint, I changed my task from the Footprint Storage to the Representation of a Process model in the part frontend. Before starting, I had to get used to the programs I needed for the frontend. For that it took a lot of time, but I think it was meaningful to start the task. First after reading the PM4py document, the code I wrote just for the test was to get the process model as output. However, the desired process model of the event log did not come out, since various files and directory were intertwined (or I did probably something wrong). But in the end I solved the error and through that I gained a sense of accomplishment that I did something right thing that I wanted. For now we don't integrate front- and backend yet, it still remains to do work and to fix some errors. But it should be done in the next sprint and I am looking forward to the remaining works."


\subsection{Liangkun He}
"In this sprint I focused on developing the front end web page in order to represent footprint table. Since the database is located in back end area and we do not integrate front and back end yet, I set the in put path as /tests. I still have some issue with unit test part which will be fix in next sprint."



\subsection{Tomasz Karg}
""
\end{document}
